Package com.norconex.commons.lang

# Enum Class Operator

java.lang.Object
java.lang.Enum<Operator>
com.norconex.commons.lang.Operator

All Implemented Interfaces:
  `Serializable`, `Comparable<Operator>`, `Constable`

public enum Operator extends Enum<Operator>

Operators used by a few conditions based on comparable values (e.g., numbers, dates, etc.). Facilitates specifying/parsing such operators as strings

## Textual representation:

Operators can be parsed using symbols or text abbreviations. Text abbreviations are useful when you do now want to concern yourself when used in XML. Possible representations are:

Text representation of operator symbols
Symbol | Abbreviation | Meaning
--- | --- | ---
> | gt | greater than
>=, => | ge | greater equal
< | lt | lower than
<=, =< | le | lowe equal
=, == | eq,is | equals

Since:
  2.0.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `EQUALS`
  `GREATER_EQUAL`
  `GREATER_THAN`
  `LOWER_EQUAL`
  `LOWER_THAN`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract <T extends Comparable<T>>
  boolean`
  `evaluate(T first, T second)`
  `static Operator`
  `of(String op)`
  `String`
  `toString()`
  `static Operator`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Operator[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### GREATER_THAN

    public static final Operator GREATER_THAN

  - ### GREATER_EQUAL

    public static final Operator GREATER_EQUAL

  - ### EQUALS

    public static final Operator EQUALS

  - ### LOWER_EQUAL

    public static final Operator LOWER_EQUAL

  - ### LOWER_THAN

    public static final Operator LOWER_THAN

- ## Method Details

  - ### values

    public static Operator[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Operator valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### of

    public static Operator of(String op)

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Enum<Operator>`

  - ### evaluate

    public abstract <T extends Comparable<T>> boolean evaluate(T first, T second)